//************************************************************************************
//**  
//**  Source name:   D:\DATA\FlowCode\FlowCode Projects\CCP_P12\CCP_ADC_P12.fcfx
//**  Title:         
//**  Description:   
//**  Device:        PIC.12F.12F675
//**  
//**  Generated by:  Flowcode v6.1.0.0
//**  Date:          Sunday, November 30, 2014 21:52:17
//**  Users:         1
//**  Registered to: Peter Erasmus
//**  Licence key:   TZJZ7M
//**  
//**  
//**  http://www.matrixtsl.com
//**  
//************************************************************************************


#define MX_PIC

#define MX_CAL_PIC

#define MX_CLK_SPEED 10000000

#define FCP_NULL Unconnected_Port

#define porta gpio
#define trisa trisio

#ifdef _BOOSTC
#pragma DATA 0x2007, 0x3FE2
#endif
#ifdef HI_TECH_C
__CONFIG(0x3FE2);
#endif

/*========================================================================*\
   Use :Mit Typdefinitionen
\*========================================================================*/
#include "C:\Program Files\Flowcode 6\CAL\internals.c"



/*========================================================================*\
   Use :panel
       :Deklarationen zu Variablen
       :Deklarationen zur Makrofunktion
\*========================================================================*/
#define FCV_FALSE (0)
#define FCV_TRUE (1)
MX_GLOBAL MX_BOOL FCV_FALLINGEDGE = (0); // Holds the value of the Edge detected
MX_GLOBAL MX_UINT8 FCV_PULSETIME = (0x0);
MX_GLOBAL MX_UINT16 FCV_NUMCYCLES = (0x0); // Holds the 16bit value of the pulse cycle time
MX_GLOBAL MX_BOOL FCV_OUTPUTEDGE = (0);

void FCM_SetPulse();
void FCM_ReadPulse();

/*========================================================================*\
   Use :Mit Chip Adaption Layer
\*========================================================================*/
#include "C:\Program Files\Flowcode 6\CAL\includes.c"


/*========================================================================*\
   Use :panel
       :Makro-Implementierungen
\*========================================================================*/
/*=----------------------------------------------------------------------=*\
   Use :
\*=----------------------------------------------------------------------=*/
void FCM_SetPulse()
{

	// C-Code
	// C-Code:
	/*****************************************
	  set the Output pulse
	******************************************/
	intcon.T0IF = 0;  // clear interrupt flag
	//-----------------------------------------
	switch(FCV_OUTPUTEDGE)
	{
	  case 0:
	   tmr0 = (FCV_PULSETIME +10);
	   FCV_OUTPUTEDGE = 1;
	   porta.1 = 1;
	  break;

	  case 1:
	   tmr0 = (FCV_PULSETIME + 10);
	   FCV_OUTPUTEDGE = 0;
	   porta.1 = 0;
	  break;
	}
	//------------------------------------------


}

/*=----------------------------------------------------------------------=*\
   Use :
\*=----------------------------------------------------------------------=*/
void FCM_ReadPulse()
{

	// Read the Input Pulse Time
	// C-Code:
	/*********************************************
	 Read low part of Duty Cycle
	**********************************************/
	switch (FCV_FALLINGEDGE)
	{
	  case 0:
	  t1con.TMR1ON = 1;
	  FCV_FALLINGEDGE = 1;   // Falling edge was detected
	  option_reg.INTEDG = 1; // Set for rising edge
	  intcon.INTF = 0;       // clear interrupt Flag  
	 break;
	//----------------------------------------------
	// Get the Pulse time
	//----------------------------------------------
	  case 1:
	  t1con.TMR1ON = 0; 
	  intcon.INTF = 0;       // clear interrupt Flag
	  option_reg.INTEDG = 0; // Set for falling edge
	  FCV_FALLINGEDGE = 0;  // Set to it was rising edge
	  FCV_NUMCYCLES = (tmr1h*256) + tmr1l;
	  tmr1h = tmr1l = 0; //clear the timer values 
	  FCV_PULSETIME = (FCV_NUMCYCLES/8);   
	  break;
	}
	//---------------------------------------------

}



/*========================================================================*\
   Use :Main
\*========================================================================*/
void main()
{

ansel = 0x20;
cmcon = 0x07;


option_reg = 0xC0;



	// Confugure Timer 1 
	// C-Code:
	/*****************************************
	 Configure Timer 1 to measure pulse 
	*******************************************/
	t1con = 0x30;
	tmr1h = 0;
	tmr1l = 0;
	//----------------------------------------
	// prescaler 1:8
	// Timer OFF
	// Clock = FOSC/4
	//----------------------------------------


	// Set GPIO 1 Off
	// Ausgang: false -> A1
	FCP_SET(B, A, 0x02, 1, (FCV_FALSE));
	// Timer 0 Interrupt
	// Unterbrechung: Aktiviere TMR0
	cr_bit(option_reg,T0CS);
	st_bit(option_reg,T0SE);
	option_reg = (option_reg & 0xF0) | 0x07;
	st_bit(intcon,GIE);
	st_bit(intcon, T0IE);

	// INT0  Interrupt
	// Unterbrechung: Aktiviere INT0
	cr_bit(option_reg,INTEDG);
	st_bit(intcon,GIE);
	st_bit(intcon, INTE);

	// Schleife
	// Schleife: While 1
	while (1)
	{


	}

	mainendloop: goto mainendloop;
}




/*========================================================================*\
   Use :Unterbrechung
\*========================================================================*/
void MX_INTERRUPT_MACRO(void)
{


	//Handler code for [TMR0]
	#ifndef MX_INTHANDLER_intcon_T0IF
	#define MX_INTHANDLER_intcon_T0IF
	if (ts_bit(intcon, T0IF) && ts_bit(intcon, T0IE))
	{
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 1;
		#endif	
		FCM_SetPulse();
		cr_bit(intcon, T0IF);
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 0;
		#endif	
	}
	#else
	#warning "This interrupt has previously been enabled, so the macro <SetPulse> may never get called."
	#endif


	//Handler code for [INT0]
	#ifndef MX_INTHANDLER_intcon_INTF
	#define MX_INTHANDLER_intcon_INTF
	if (ts_bit(intcon, INTF) && ts_bit(intcon, INTE))
	{
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 1;
		#endif	
		FCM_ReadPulse();
		cr_bit(intcon, INTF);
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 0;
		#endif	
	}
	#else
	#warning "This interrupt has previously been enabled, so the macro <ReadPulse> may never get called."
	#endif


}





